<%@ page session="false" %>

<%@ page import="ch.tvbauma.opencms.module.guestbook.*" %>

<%@ page import="com.opencms.workplace.*" %>
<%@ page import="com.opencms.file.*" %>
<%@ page import="com.opencms.flex.jsp.*" %>

<%@ page import="java.util.*" %>

<%@ taglib prefix="cms" uri="http://www.opencms.org/taglib/cms" %>
<cms:include property="template" suffix=".jsp" element="head" />

<%
// set headers that browser/proxies shouldn't cache the page
response.addHeader("Pragma" , "No-cache");
response.addHeader("Cache-Control", "no-cache");
response.addDateHeader("Expires", 0);

// get the cms stuff
CmsJspActionElement cmsa = new CmsJspActionElement(pageContext, request, response);
CmsObject cms = cmsa.getCmsObject();

// determine used params
String action = request.getParameter("action");
String author = "";
String email = "";
String link = "http://";
String text = "";
String error = "";

if (action == null || "".equals(action))
  action = "show";

// switch to wished action
if ("create".equals(action)) {

  // get params
  author = request.getParameter("author");
  email = request.getParameter("email");
  link = request.getParameter("link");
  text = request.getParameter("text");

  // clear params
  if (author == null)
    author = "";

  if (text == null)
    text = "";

  if (email == null)
    email = "";

  if (link == null || "http://".equals(link))
    link = "";

  // get patterns for input validation
  CmsXmlLanguageFile lang = new CmsXmlLanguageFile(cms);
  String prefix = "ch_tvbauma_opencms_module_guestbook_jsp.pattern.";

  String patternAuthor = lang.getLanguageValue(prefix + "name");
  String patternText = lang.getLanguageValue(prefix + "text");
  String patternEmail = lang.getLanguageValue(prefix + "email");
  String patternLink = lang.getLanguageValue(prefix + "link");

  String messageAuthor = lang.getLanguageValue(prefix + "name.message");
  String messageText = lang.getLanguageValue(prefix + "text.message");
  String messageEmail = lang.getLanguageValue(prefix + "email.message");
  String messageLink = lang.getLanguageValue(prefix + "link.message");
  String messageSmiley = lang.getLanguageValue(prefix + "tag.message");
  String messageInvalidPattern = lang.getLanguageValue(prefix + "invalid.message");

  // input validation
  boolean isInputValidated = false;

  try {
    isInputValidated = ("".equals(author) || Util.check(author, patternAuthor)) &&
                       ("".equals(text) || Util.check(text, patternText) || Util.checkSmileyTags(text, cms)) &&
                       ("".equals(email) || Util.check(email, patternEmail)) &&
                       ("".equals(link) || Util.check(link, patternLink));

    if (! ("".equals(author) || Util.check(author, patternAuthor)))
      error += messageAuthor + "<br>";

    if (! ("".equals(text) || Util.check(text, patternText))) {
      error += messageText + "<br>";
    }
    else {
      if (!Util.checkSmileyTags(text, cms))
        error += messageSmiley;
    }

    if (! ("".equals(email) || Util.check(email, patternEmail)))
      error += messageEmail + "<br>";

    if (! ("".equals(link) || Util.check(link, patternLink)))
      error += messageLink + "<br>";
  }
  catch (Exception ex) {
    // isInputValidated is still false... ok do nothing
    error += messageInvalidPattern + "<br>";
  }

  if ("".equals(author))
    error += "Required Field Author is empty<br>";

  if ("".equals(text))
    error += "Required Field Text is empty<br>";

  if (!"".equals(error)) {
    action = "new";
  }
  else {
    // insert new entry
    GuestbookContentDefinition gcd = new GuestbookContentDefinition(author, text, email, link);
    gcd.write(cms);

    response.sendRedirect("guestbook.jsp");
    return;
  }
}

if ("new".equals(action)) {
%>
<!----------------------------- PART NEW ENTRY ---------------------------->
<h1>New Guestbook Entry</h1>
<form action="guestbook.jsp" methode="get">
  <input type="hidden" name="action" value="show">
  <input type="submit" value="<< List...">
</form>
<hr>
<form action="guestbook.jsp">
<table width="100%">
  <tr>
    <td width="100">Author: *</td>
    <td><input type="text" name="author" size="50" maxlength="50" value="<%=author%>"></td>
  </tr>
  <tr>
    <td width="100">Email:</td>
    <td><input type="text" name="email" size="50" maxlength="50" value="<%=email%>"></td>
  </tr>
  <tr>
    <td width="100">Link:</td>
    <td><input type="text" name="link" size="50" maxlength="100" value="<%=link%>"></td>
  </tr>
  <tr>
    <td width="100">Text: *</td>
    <td><textarea name="text" rows="10" cols="50"><%=text%></textarea></td>
  </tr>
  <tr>
    <td width="100"></td>
    <td><%=Util.getAllSmileysAsHTML(cms, "../../export/pics/")%></td>
  </tr>
  <% // check if an error occured
  if (!"".equals(error)) {
  %>
  <tr>
    <td width="100"></td>
    <td><br><%=error%></td>
  </tr>
  <%
  }
  %>
  <tr>
    <td width="100"></td>
    <td><br><input type="submit" value="Create"><input type="reset" value="Clear"></td>
  </tr>
</table>
<input type="hidden" name="action" value="create">
</form>
<%
} // end of part NEW

if ("show".equals(action)) {
// if action is wether new nor create show the entries
%>
<!----------------------------- PART HEAD ---------------------------->
<h1>Guestbook Entries</h1>

<form action="guestbook.jsp" method="get">
  <input type="hidden" name="action" value="new">
  <input type="submit" value="New &gt;&gt;">
</form>
<hr>
<!----------------------------- PART ENTRIES ---------------------------->
<% // Iterate over all entries and build table
Vector vecEntries = GuestbookContentDefinition.getAllEntries();
Iterator it = vecEntries.iterator();

while (it.hasNext()) {
  GuestbookContentDefinition gcd = (GuestbookContentDefinition)it.next();
%>
<table width="100%">
  <tr>
    <td width="100">Date:</td>
    <td><%=gcd.getFormatedDate()%> - <%=gcd.getFormatedTime()%></td>
  </tr>
  <tr>
    <td width="100">Author:</td>
    <td><%=gcd.getAuthor()%></td>
  </tr>
  <% // only display if email adress is available
  if (gcd.getEmail() != null && !gcd.getEmail().equals("")) {
  %>
  <tr>
    <td width="100">Email:</td>
    <td><a href="mailto:<%=gcd.getEmail()%>"><%=gcd.getEmail()%></a></td>
  </tr>
  <%
  }
  // only display if link is available
  if (gcd.getLink() != null && !gcd.getLink().equals("")) {
  %>
  <tr>
    <td width="100">Link:</td>
    <td><a href="<%=gcd.getLink()%>"><%=gcd.getLink()%></a></td>
  </tr>
  <%
  }
  %>
  <tr>
    <td width="100">Text:</td>
    <td><%=Util.replaceSmileyTags(gcd.getText(), "../../export/pics/", cms)%></td>
  </tr>
</table>
<hr>
<%
}
%>
<%
} // end of part SHOW
%>
<cms:include property="template" suffix=".jsp" element="foot" />