<%@ page session="false" %>

<%@ taglib prefix="cms" uri="http://www.opencms.org/taglib/cms" %>
<cms:include property="template" suffix=".jsp" element="head" />

<h1>Guestbook Demo Page</h1>
<b>Credits</b>
<ul>
<li>Cyrill Brunschwiler - Base Module, Backoffice Enhancement, Smiley Support, JSPs, Security Considerations
<li>Jens Roleff - Testing Base Module
</ul>
<b>Disclamer</b>
<ul>
<li>This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
 implied warranty of merchantability or fitness for a particular purpose. See the GNU Lesser General Public
 License for more details. FURTHER IT WOULD BE NICE IF YOU INFORM THE COMMUNITY ABOUT CHANGES YOU MADE !!!!!
</ul>
<b>Short Description</b>
<ul>
<li>Allows to create guestbook entries. User could enter his name, email adress, a link and a text.
<li>The module supports also to insert smileys just by enter the right tag into the text field.
</ul>
<b>Features</b>
<ul>
<li>Supports input validation by regular expressions to avoid arbitrary code injection and as a result to increase security
<li>The back office part of the guestbook module supports: create, edit, delete and filtered look up by author or text
<li>Easy enhancement of smileys just by upload any pictures into the guestbooks picture gallery
<li>Uses opencms connection pooling
<li>Ready for workplace translation to other languages
</ul>
<b>Known Issues</b>
<ul>
<li>Users are able to insert the same entry more than once... could lead to a DOS Attack
<li>Some workplace properties should be moved to the modules registry because they aren't really language properties
</ul>
<b>Documentation</b><br>
<ul>
<li>There's just this bit of documentation. If you want to know anything special, have a look at the code and java doc (create it yourself)
<li>Database properties will be found in the modules registry. go for Workplace->Module management->Guestbook module->Administrate...
<li>Date and time format properties are also found in the registry
<li>All other properties will be found in the workplace.properties(_locale)
<li>In fact of java escapes each backslash, backslashes in any regular expression needs to be doubled
<li>Pictures which should be choosable while creating a new entry have to consist of small letters and numbers by default
<li>There are few more useful methods to improve your guestbook in the content defininiton class (such as get the number of entries or getting a single entry)
<li>Never forget... time will tell
</ul>
<b>Test Environment</b><br>
<ul>
<li>OpenCMS 5.0
<li>Tomcat 4.0.6
<li>JDK Version 1.4.1-b21
<li>mySQL 3.23.49
<li>Windows 2000 SP2
</ul>
<b>Bugs</b><br>
<ul>
<li>No known bugs
</ul>
<b>Support</b>
<ul>
<li>No Support
</ul>

<cms:include property="template" suffix=".jsp" element="foot" />
